All of lore.kernel.org
 help / color / mirror / Atom feed
From: Shiyang Ruan <ruansy.fnst@fujitsu.com>
To: <fstests@vger.kernel.org>
Cc: <ruansy.fnst@fujitsu.com>
Subject: [PATCH v3 15/17] generic: add race test between reflink and mmap read
Date: Tue, 14 Dec 2021 16:19:12 +0800	[thread overview]
Message-ID: <20211214081914.2478122-16-ruansy.fnst@fujitsu.com> (raw)
In-Reply-To: <20211214081914.2478122-1-ruansy.fnst@fujitsu.com>

Test for races or FS corruption between reflink and mmap reading the
target file. (MMAP version of generic/164,165)

Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com>
---
 common/reflink        | 11 +++++++
 tests/generic/913     | 72 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/913.out |  5 +++
 3 files changed, 88 insertions(+)
 create mode 100755 tests/generic/913
 create mode 100644 tests/generic/913.out

diff --git a/common/reflink b/common/reflink
index 68dbdedd..455260c6 100644
--- a/common/reflink
+++ b/common/reflink
@@ -186,6 +186,17 @@ _read_range() {
 	$XFS_IO_PROG $xfs_io_args -f -c "pread -q -v $offset $len" "$file" | cut -d ' ' -f '3-18'
 }
 
+# Prints a range of a file as a hex dump
+_mread_range() {
+	file="$1"
+	offset="$2"
+	len="$3"
+	xfs_io_args="$4"
+
+	$XFS_IO_PROG $xfs_io_args -f -c "mmap -rw 0 $((offset + len))" \
+		-c "mread -v $offset $len" "$file" | cut -d ' ' -f '3-18'
+}
+
 # Compare ranges of two files
 _compare_range() {
 	file1="$1"
diff --git a/tests/generic/913 b/tests/generic/913
new file mode 100755
index 00000000..f709c36c
--- /dev/null
+++ b/tests/generic/913
@@ -0,0 +1,72 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# FS QA Test No. 913
+#
+# Test for races or FS corruption between reflink and mmap reading the
+# target file. (MMAP version of generic/164,165)
+#
+. ./common/preamble
+_begin_fstest auto clone
+
+_register_cleanup "_cleanup" BUS
+
+# Import common functions.
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_require_scratch_reflink
+_require_cp_reflink
+
+echo "Format and mount"
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+finished_file=/tmp/finished
+rm -rf $finished_file
+mkdir $testdir
+
+loops=512
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize files"
+echo >> $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_pwrite_byte 0x62 0 $((loops * blksz)) $testdir/file2 >> $seqres.full
+_cp_reflink $testdir/file1 $testdir/file3
+_scratch_cycle_mount
+
+fbytes() {
+	egrep -v '(61 61 61 61 61 61 61 61 61 61 61 61 61 61 61 61|62 62 62 62 62 62 62 62 62 62 62 62 62 62 62 62)'
+}
+
+reader() {
+	while [ ! -e $finished_file ]; do
+		_mread_range $testdir/file3 0 $((loops * blksz)) | fbytes
+	done
+}
+
+echo "Reflink and mmap reread the files!"
+reader &
+for i in `seq 1 2`; do
+	seq $nr_loops -1 0 | while read i; do
+		_reflink_range  $testdir/file1 $((i * blksz)) \
+				$testdir/file3 $((i * blksz)) $blksz >> $seqres.full
+		[ $? -ne 0 ] && break
+	done
+	seq $nr_loops -1 0 | while read i; do
+		_reflink_range  $testdir/file2 $((i * blksz)) \
+				$testdir/file3 $((i * blksz)) $blksz >> $seqres.full
+		[ $? -ne 0 ] && break
+	done
+done
+echo "Finished reflinking"
+touch $finished_file
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/913.out b/tests/generic/913.out
new file mode 100644
index 00000000..a34df6ce
--- /dev/null
+++ b/tests/generic/913.out
@@ -0,0 +1,5 @@
+QA output created by 913
+Format and mount
+Initialize files
+Reflink and mmap reread the files!
+Finished reflinking
-- 
2.34.1




  parent reply	other threads:[~2021-12-14  8:19 UTC|newest]

Thread overview: 22+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-12-14  8:18 [PATCH v3 00/17] generic: add some mmap CoW tests Shiyang Ruan
2021-12-14  8:18 ` [PATCH v3 01/17] generic: add mmap CoW test for ranges of two shared files Shiyang Ruan
2021-12-14  8:18 ` [PATCH v3 02/17] generic: add mmap CoW test for regular&destination extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 03/17] generic: add mmap CoW test for unwritten&destination extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 04/17] generic: add mmap CoW test for holes&destination extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 05/17] common/rc: Introduce _require_scratch_delalloc() Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 06/17] generic: add mmap CoW test for delalloc&destination extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 07/17] generic: add mmap CoW test for mixed&destination extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 08/17] generic: add mmap CoW test for regular&source extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 09/17] generic: add mmap CoW test for unwritten&source extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 10/17] generic: add mmap CoW test for holes&source extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 11/17] generic: add mmap CoW test for delalloc&source extents Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 12/17] generic: add buffered-io CoW test for mixed&source extents Shiyang Ruan
2021-12-25 13:27   ` Eryu Guan
2021-12-14  8:19 ` [PATCH v3 13/17] generic: add direct-io " Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 14/17] generic: add mmap " Shiyang Ruan
2021-12-14  8:19 ` Shiyang Ruan [this message]
2022-01-11 18:55   ` [PATCH v3 15/17] generic: add race test between reflink and mmap read Darrick J. Wong
2022-01-12  2:38     ` Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 16/17] generic: add race test that mmap write to source of reflink Shiyang Ruan
2021-12-14  8:19 ` [PATCH v3 17/17] generic: add race test that mmap write to target " Shiyang Ruan
2021-12-19 16:04 ` [PATCH v3 00/17] generic: add some mmap CoW tests Eryu Guan

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20211214081914.2478122-16-ruansy.fnst@fujitsu.com \
    --to=ruansy.fnst@fujitsu.com \
    --cc=fstests@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.